
package simsql.code_generator;

import java.io.Serializable;

// this is the structure that tells us where the database files are actually stored
public class DatabaseFile implements Serializable {

  private String dirName;
  private Short typeCode;
  private Long sizeInBytes;  // uncompressed size.
  private Integer sortingAtt;  // sorted att. position
  private Integer numAtts; // known no. of atts.

  public DatabaseFile (String dirNameIn, Short typeCodeIn) {
    dirName = dirNameIn;
    typeCode = typeCodeIn;
    sizeInBytes = 0L;
    sortingAtt = -1;
    numAtts = 0;
  }

  public String getDirName () {
    return dirName;
  }

  public Short getTypeCode () {
    return typeCode;
  }

  public Long getSizeInBytes() {
    return sizeInBytes;
  }

  public void setSizeInBytes(Long sizeIn) {
    sizeInBytes = sizeIn;
  }

  public Integer getSortingAtt() {
    return sortingAtt;
  }

  public void setSortingAtt(Integer whichAtt) {
    sortingAtt = whichAtt;
  }

  public void setNumAtts(Integer val) {
    numAtts = val;
  }
    
  public Integer getNumAtts() {
    return numAtts;
  }
}
