
package simsql.code_generator;

import java.util.*;

/** a VG function with its name, location and sets of input and output attributes. */
class PrologQueryVGFunction {

    private String name;
    private String file;
    private ArrayList<PrologAttributeExp> inputAttributes = new ArrayList<PrologAttributeExp>();
    private ArrayList<PrologAttributeExp> outputAttributes = new ArrayList<PrologAttributeExp>();

    public PrologQueryVGFunction(TupleTerm tup, HashMap<AtomTerm, TupleTerm> allAttributes) {

	// check the arity
	tup.checkArity(4);

	// get the name
	name = ((AtomTerm)tup.getTerm(0)).getValue();

	// get the file
	file = ((AtomTerm)tup.getTerm(1)).getValue();

	// get the set of input attributes.
	for (PrologTerm t: ((ListTerm)tup.getTerm(2))) {
	    inputAttributes.add(new PrologAttributeExp(allAttributes.get(t)));
	}

	// get the set of output attributes.
	for (PrologTerm t: ((ListTerm)tup.getTerm(3))) {
	    outputAttributes.add(new PrologAttributeExp(allAttributes.get(t)));
	}
    }

    public String getName() {
	return name;
    }

    public String getFile() {
	return file;
    }

    public ArrayList<PrologAttributeExp> getInputAtts() {
	return inputAttributes;
    }

    public ArrayList<PrologAttributeExp> getOutputAtts() {
	return outputAttributes;
    }

    public String toString() {
	return name;
    }
}
