package simsql.compiler; // package mcdb.catalog;


/**
 * Represents a foreign key, composed of two mapped attributes.
 *
 * @author Luis, Bamboo
 */

public class ForeignKey {

  /** Set of source attributes */
  private Attribute srcAtt;

  /** Set of destination attributes */
  private Attribute destAtt;

  /** Public constructor */
  public ForeignKey(Attribute _srcAtt, Attribute _destAtt) {
    srcAtt = _srcAtt;
    destAtt = _destAtt;
  }

  /** Returns the set of source attributes */
  public Attribute getSrcAtt() {
    return(srcAtt);
  }

  /** Returns the set of destination attributes */
  public Attribute getDestAtt() {
    return(destAtt);
  }

  public String toString() {
    return(srcAtt + "->" + destAtt);
  }
}