/**
 *  This class is used to store the return type information for a function definition
 */
package simsql.compiler;

/**
 * @author Bamboo
 *
 */
public class TypeInfo {
	
	// the name of the type
	private String typeString;

	// and the size of the type
	private String typeSize;

	public TypeInfo (String typeIn) {
		typeString = typeIn;
		typeSize = null;
	}

	public void setTypeSize (String sizeIn) {
		typeSize = sizeIn;
	}

	public String getTypeString () {
		return typeString;
	}

	public String getTypeSizeString () {
		return typeSize;
	}

        public int getTypeSize() throws Exception {

                if(typeSize == null) {

                        typeString = typeString.toLowerCase();
                        if(typeString.equals("integer"))
                        {
                                return 32;
                        }
                        else if(typeString.equals("double"))
                        {
                                return 64;
                        }
                        else if(typeString.equals("char"))
                        {
                                //default size for String. 50 chars
                                return 50;
                        }
                        else
                        {
                                System.err.println ("I do not recognize type " + typeString);
                                throw new Exception ("I do not recognize type " + typeString);
                        }
                }
                else
                {
                        return Integer.parseInt(typeSize);
                }
        }

        public int getType() throws Exception {

                typeString = typeString.toLowerCase();
                if(typeString.equals("integer"))
                {
                        return Attribute.INTEGER;
                }
                else if(typeString.equals("double"))
                {
                        return Attribute.DOUBLE;
                }
                else if(typeString.equals("char"))
                {
                        return Attribute.STRING;
                }
                else
                {
                                System.err.println ("I do not recognize type " + typeString);
                                throw new Exception ("I do not recognize type " + typeString);
                }
        }
}
