/**
 * 
 */
package simsql.compiler; // package mcdb.compiler;

import java.io.BufferedWriter;
import java.util.regex.Pattern;
import java.util.regex.Matcher;
import java.lang.StringBuffer;
import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.StringTokenizer;
import simsql.shell.Compiler;
import simsql.shell.SimSQLCompiledQuery;
import simsql.shell.PhysicalDatabase;
import simsql.shell.RuntimeParameter;

public class IndexReplacer {

	private String query;

	public IndexReplacer (String inQuery, simsql.shell.Catalog catalog) {

		/*
                 * Pre-process the input text; if we see anything of the form myTable[34] we look
                 *    for myTable_34_saved in the catalog, and if there, we simply do a text replace
                 */

		// this will match any random table statements
		Pattern p = Pattern.compile("[a-z|A-Z|_][a-z|A-Z|0-9|_]*\\s*\\[\\s*[0-9]+\\s*\\]");
		query = inQuery;
		Matcher m = p.matcher(query);
		StringBuffer sb = new StringBuffer();
		while (m.find()) {
			
			// we found a match, so see if the table exists in the catalog
			String current = m.group ();
			String tableName = "";
			
			// find the end of the identifier
			int i = 0;
			while (current.charAt (i) != '[' && !Character.isWhitespace (current.charAt (i))) {
				tableName += current.charAt (i);
				i++;
			}

			// add in an underscore
			tableName += "_";

			// now add in the identifier
			while (current.charAt (i) != ']') {
				if (Character.isDigit (current.charAt (i)))
					tableName += current.charAt (i);
				i++;
			}

			tableName += "_saved";


			// OK, so we have the table name... see if it exists in the catalog
			if (catalog.getRelation (tableName) != null) {

				// it is there, so we replace with the table name
				m.appendReplacement(sb, tableName);
			} else {

				// it is not there, so we put it back
     				m.appendReplacement(sb, current);
			}
 		}
		m.appendTail(sb);
		query = sb.toString();

	}

	public String getOutput () {
		return query;
	}
}

