/**
 * 
 */
package simsql.compiler; // package mcdb.compiler.logicPlan.logicOperator.booleanOperator;

import java.util.ArrayList;


// import mcdb.compiler.logicPlan.logicOperator.CopyHelper;

/**
 * @author Bamboo
 *
 */
public class AndOperator extends BooleanOperator{

	private ArrayList<BooleanOperator> operatorList;
	/**
	 * @param name
	 */
	public AndOperator(String name) {
		super(name);
	}
	
	public AndOperator(String name, ArrayList<BooleanOperator> operatorList)
	{
		this(name);
		this.operatorList = operatorList;
	}

	public ArrayList<BooleanOperator> getOperatorList() {
		return operatorList;
	}

	public void setOperatorList(ArrayList<BooleanOperator> operatorList) {
		this.operatorList = operatorList;
	}

	/* (non-Javadoc)
	 * @see logicOperator.booleanOperator.BooleanOperator#visitNode()
	 */
	@Override
	public String visitNode() {
		String result = "boolAnd(" + this.getName() + ", [";
		
		if(operatorList != null)
		{
			for(int i = 0 ; i < operatorList.size(); i++)
			{
				result += operatorList.get(i).getName();
				
				if(i != operatorList.size() - 1)
				{
					result += ", ";
				}
			}
		}
		
		result += "]).\r\n";
		
		if(operatorList != null)
		{
			for(int i = 0 ; i < operatorList.size(); i++)
			{
				result += operatorList.get(i).visitNode();
			}
		}
		return result;
	}

	/* (non-Javadoc)
	 * @see mcdb.compiler.logicPlan.logicOperator.booleanOperator.BooleanOperator#copy()
	 */
	@Override
	public BooleanOperator copy(CopyHelper copyHelper) {
		String c_name = new String(this.getName());
		ArrayList<BooleanOperator> c_operatorList = copyHelper.copyBooleanOperatorList(operatorList);
		
		AndOperator c_operator = new AndOperator(c_name, c_operatorList);
		
		return c_operator;
	}
	
}
