/**
 * 
 */
package simsql.compiler; // package mcdb.compiler.parser.expression.sqlExpression;


/**
 * @author Bamboo
 *
 */
public class AttributeDefineElement extends SQLExpression
{
	public String attributeName;
	public String typeString;
	public String typeSize;
	public boolean input;
	public boolean isRandom = false;

	public AttributeDefineElement(String attributeName, String typeString) {
		super();
		this.attributeName = attributeName.toLowerCase();
		this.typeString = typeString.toLowerCase();
		this.typeSize = null;
		this.input = true;
	}

	

	public AttributeDefineElement(String attributeName, String typeString,
			String typeSize) {
		super();
		this.attributeName = attributeName.toLowerCase();
		this.typeString = typeString.toLowerCase();
		this.typeSize = typeSize;
		this.input = true;
	}

	public String getAttributeName() {
		return attributeName;
	}

	public int getType() throws Exception
	{
		typeString = typeString.toLowerCase();
		if(typeString.equals("integer"))
		{
			return Attribute.INTEGER;
		}
		else if(typeString.equals("double"))
		{
			return Attribute.DOUBLE;
		}
		else if(typeString.equals("char"))
		{
			return Attribute.STRING;
		}
		else
		{
			System.err.println("Attribute[" + attributeName +"] has wrong type size!");
			throw new Exception("Attribute[" + attributeName +"] has wrong type size!");
		}
	}
	
	
	public void setRandom (boolean toMe) {
		isRandom = toMe;
	}
	
	public boolean getIsRandom () {
		return isRandom;
	}
	
	public boolean isInput() {
		return input;
	}

	public void setInput(boolean input) {
		this.input = input;
	}



	public String getTypeString() {
		return typeString;
	}


	public String getTypeSizeString() {
		return typeSize;
	}

	public void setTypeSizeString(String typeSize) {
		this.typeSize = typeSize;
	}

	public int getTypeSize() throws Exception
	{
		if(typeSize == null)
		{
			typeString = typeString.toLowerCase();
			if(typeString.equals("integer"))
			{
				return 32;
			}
			else if(typeString.equals("double"))
			{
				return 64;
			}
			else if(typeString.equals("char"))
			{
				//default size for String: 50 chars
				return 50;
			}
			else
			{
				System.err.println("Attribute[" + attributeName +"] has wrong type size!");
				throw new Exception("Attribute[" + attributeName +"] has wrong type size!");
			}
		}
		else
		{
			return Integer.parseInt(typeSize);
		}
	}

	/* (non-Javadoc)
	 * @see mcdb.compiler.parser.expression.sqlExpression.SQLExpression#acceptVisitor(mcdb.compiler.parser.astVisitor.ASTVisitor)
	 */
	@Override
	public boolean acceptVisitor(ASTVisitor astVisitor) throws Exception
	{
		return astVisitor.visitAttributeElement(this);	
	}

}
