/**
 * 
 */
package simsql.compiler; // package mcdb.compiler.parser.astVisitor;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;

/**
 * @author Bamboo
 *
 */
public class BaseLineRandomTableTypeChecker extends RandomTableTypeChecker 
{
	public String indexString = "";
	/**
	 * @param allowDuplicatedAttributeAlias
	 * @throws Exception
	 */
	public BaseLineRandomTableTypeChecker(boolean allowDuplicatedAttributeAlias)
			throws Exception {
		super(allowDuplicatedAttributeAlias);
	}

	/**
	 * @param baseLineRandomTableStatement
	 * @return
	 */
	public boolean visitBaseLineRandomTableStatement(
			BaseLineRandomTableStatement baseLineRandomTableStatement) throws Exception
	{
		indexString = baseLineRandomTableStatement.indexString;
		
		int errorNum = 0;
		/*
		 * 2. indexString
		 */
		String indexString = baseLineRandomTableStatement.indexString;
		try
		{
			int index = Integer.parseInt(indexString);
			if(index < 0)
			{
				errorNum ++;
				System.err.println("The index [" + indexString +"] is not valid!" );
			}
		}
		catch(Exception e)
		{
			errorNum ++;
			System.err.println("The index [" + indexString +"] is not valid!" );
		}
		
		if(errorNum > 0)
		{
			return false;
		}
		
		return super.visitRandomTableStatement(baseLineRandomTableStatement);
	}
	
	public void saveView(DefinedTableSchema tableAttributes, 
            ArrayList<Integer> gottenAttributeTypeList,
            String sql) throws Exception
	{
		String viewName;
		
		viewName = tableAttributes.viewName;
		
		ArrayList<String> attributeNameList = tableAttributes.tableAttributeList;
		ArrayList<Integer> attributeTypeList = gottenAttributeTypeList;

		ArrayList<Attribute> schema = new ArrayList<Attribute>();
		// The view explicitly define the schema
		if (attributeNameList != null) {
			for (int i = 0; i < attributeNameList.size(); i++) {
				String name = attributeNameList.get(i);
				int type = attributeTypeList.get(i);
				Attribute attribute = new Attribute(name, type, viewName);
				schema.add(attribute);
			}
		}
		else {
			for (int i = 0; i < attributeTypeList.size(); i++) {
				String name = attributeList.get(i);
				int type = attributeTypeList.get(i);
				Attribute attribute = new Attribute(name, type, viewName);
				schema.add(attribute);
			}
		}

		View view = new View(viewName, sql, schema, DataAccess.OBJ_RANDRELATION);
		catalog.addView(view);
		
		int end = viewName.lastIndexOf("_");
		String realViewName = viewName.substring(0, end);
		catalog.addIndexTable(realViewName, viewName);
		catalog.addMCDependecy(viewName, this.getIndexedRandomTableList());
	}

}
