package simsql.compiler;


public class BaselineTableName extends SQLExpression{

	private String name;
	private String index;
	
	public BaselineTableName(String name, String index)
	{
		this.index = index;
		this.name = name;
	}
	
	@Override
	public boolean acceptVisitor(ASTVisitor astVisitor) throws Exception {
		return astVisitor.visitBaselineTableNameTable(this);	
	}

	@Override
	public String toString()
	{
		return name+"[" + index + "]";
	}

	public String getName() {
		return name;
	}
	
	public String getVersionedName()
	{
		return name  +"_" + index;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getIndex() {
		return index;
	}

	public void setIndex(String index) {
		this.index = index;
	}
	
	public int getIndexValue()
	{
		return Integer.parseInt(index);
	}

}

