/**
 * 
 */
package simsql.compiler; // package mcdb.compiler.logicPlan.postProcessor;

import java.util.ArrayList;



// import mcdb.compiler.logicPlan.logicOperator.booleanOperator.AndOperator;
// import mcdb.compiler.logicPlan.logicOperator.booleanOperator.AtomOperator;
// import mcdb.compiler.logicPlan.logicOperator.booleanOperator.BooleanOperator;
// import mcdb.compiler.logicPlan.logicOperator.booleanOperator.CompOperator;
// import mcdb.compiler.logicPlan.logicOperator.booleanOperator.NotOperator;
// import mcdb.compiler.logicPlan.logicOperator.booleanOperator.OrOperator;
// import mcdb.compiler.logicPlan.logicOperator.mathOperator.MathOperator;
// import mcdb.compiler.logicPlan.logicOperator.relationOperator.Operator;

/**
 * @author Bamboo
 * 
 */
public class BooleanOperatorReplacer {
	private Operator operator;

	public BooleanOperatorReplacer(Operator operator) {
		this.operator = operator;
	}
	
	public void replaceAttributeInBooleanOperator(BooleanOperator element) 
	{
		if (element instanceof AndOperator) 
		{
			replaceAttributeInAndOperator((AndOperator) element);
		} 
		else if (element instanceof AtomOperator) 
		{
			replaceAttributeInAtomOperator((AtomOperator) element);
		} 
		else if (element instanceof CompOperator )
		{
			replaceAttributeInCompOperator((CompOperator) element);
		} 
		else if (element instanceof NotOperator ) 
		{
			replaceAttributeInNotOperator((NotOperator) element);
		} 
		else if (element instanceof OrOperator) 
		{
			replaceAttributeInOrOperator((OrOperator) element);
		} 
	}

	/**
	 * @param element
	 * @return
	 */
	private void replaceAttributeInAndOperator(AndOperator element) {
		ArrayList<BooleanOperator> operatorList = element.getOperatorList();
		if(operatorList != null)
		{
			for(int i = 0; i < operatorList.size(); i++)
			{
				replaceAttributeInBooleanOperator(operatorList.get(i));
			}
		}
	}

	/**
	 * @param element
	 * @return
	 */
	private void replaceAttributeInAtomOperator(AtomOperator element) {
		return;
	}

	/**
	 * @param element
	 * @return
	 */
	private void replaceAttributeInCompOperator(CompOperator element) 
	{
		MathOperator left = element.getLeft();
		MathOperator right = element.getRight();
		
		MathOperatorReplacer mathReplacer = new MathOperatorReplacer(operator);
		
		if(left != null)
			mathReplacer.replaceAttributeInMathOperator(left);
		
		if(right != null)
			mathReplacer.replaceAttributeInMathOperator(right);
	}

	/**
	 * @param element
	 * @return
	 */
	private void replaceAttributeInNotOperator(NotOperator element) {
		BooleanOperator operator = element.getBooleanOperator();
		if(operator != null)
		{
			replaceAttributeInBooleanOperator(operator);
		}
	}

	/**
	 * @param element
	 * @return
	 */
	private void replaceAttributeInOrOperator(OrOperator element) {
		ArrayList<BooleanOperator> operatorList = element.getOperatorList();
		if(operatorList != null)
		{
			for(int i = 0; i < operatorList.size(); i++)
			{
				replaceAttributeInBooleanOperator(operatorList.get(i));
			}
		}
	}

	public Operator getOperator() {
		return operator;
	}

	public void setOperator(Operator operator) {
		this.operator = operator;
	}
	
	

}
