/**
 * 
 */
package simsql.compiler; // package mcdb.compiler.parser.unnester;

import java.util.ArrayList;
import java.util.HashMap;



// import mcdb.compiler.parser.expression.mathExpression.ColumnExpression;
// import mcdb.compiler.parser.expression.sqlExpression.SQLExpression;



/**
 * @author Bamboo
 *
 */
public class CheckerEdge {
	private ArrayList<SQLExpression> tableReferenceList;
	private HashMap<SQLExpression, ArrayList<ColumnExpression>> columnReferenceMap;
	
	public CheckerEdge()
	{
		tableReferenceList = new ArrayList<SQLExpression>();
		columnReferenceMap = new HashMap<SQLExpression, ArrayList<ColumnExpression>>();
	}
	
	public CheckerEdge(ArrayList<SQLExpression> tableReferenceList,
					   HashMap<SQLExpression, ArrayList<ColumnExpression>> columnReferenceMap)
	{
		this.tableReferenceList = tableReferenceList;
		this.columnReferenceMap = columnReferenceMap;
	}
	
	public boolean containTableReference(SQLExpression expression)
	{
		return tableReferenceList.contains(expression);
	}
	
	public void addTableReference(SQLExpression expression)
	{
		/*
		 * for testing
		 */
		if(expression == null)
		{
			//System.out.println("testing");
		}
		if(!tableReferenceList.contains(expression))
		{
			tableReferenceList.add(expression);
		}
	}
	
	public void addColumnExpression(SQLExpression expression, ColumnExpression column)
	{
		if(columnReferenceMap.containsKey(expression))
		{
			ArrayList<ColumnExpression> tempList = columnReferenceMap.get(expression);
			if(!tempList.contains(column))
			{
				tempList.add(column);
			}
		}
		else
		{
			ArrayList<ColumnExpression> tempList = new ArrayList<ColumnExpression>();
			tempList.add(column);
			columnReferenceMap.put(expression, tempList);
		}
	}

	public ArrayList<SQLExpression> getTableReferenceList() {
		return tableReferenceList;
	}

	public void setTableReferenceList(ArrayList<SQLExpression> tableReferenceList) {
		this.tableReferenceList = tableReferenceList;
	}

	public HashMap<SQLExpression, ArrayList<ColumnExpression>> getColumnReferenceMap() {
		return columnReferenceMap;
	}

	public void setColumnReferenceMap(
			HashMap<SQLExpression, ArrayList<ColumnExpression>> columnReferenceMap) {
		this.columnReferenceMap = columnReferenceMap;
	}
	
	
}
