package simsql.compiler; // package mcdb.compiler.parser.expression.mathExpression;

import java.util.ArrayList;


// import mcdb.compiler.parser.astVisitor.ASTVisitor;



/*
 * @Author: Bamboo
 *  Date: 09/02/2010
 *  This class corresponds to columns used by group by sub clause
 */


public class ColumnExpression extends MathExpression {
	//table name
	public String table;
	public String columnName;
	
	//whether this column expression is in gropuby subclause
	private boolean isGroupByColumn; 
	
	public ColumnExpression(String table, String columnName) {
		super();
		this.table = table;
		this.columnName = columnName;
		isGroupByColumn = false;
	}
	
	public boolean isGroupByColumn() {
		return isGroupByColumn;
	}

	public void setIsGroupByColumn(boolean isGroupByColumn) {
		this.isGroupByColumn = isGroupByColumn;
	}
	
	public boolean equals(ColumnExpression expression)
	{
		if(expression == null)
			return false;
		
		return table.equals(expression.table) && columnName.equals(expression.columnName);
	}

	@Override
	public ArrayList<Integer> acceptVisitor(ASTVisitor astVisitor)  throws Exception{
		return astVisitor.visitColumnExpression(this);	
	}

	@Override
	public String toString()
	{
		if(table == null)
			return columnName;
		else
			return table + "_" + columnName;
	}
	
}
