package simsql.compiler;

import java.util.ArrayList;


public class DefinedArrayTableSchema extends DefinedTableSchema {
	public String lowerBound;
	public String upBound;
	
	public DefinedArrayTableSchema(String viewName, 
								   String arrayString,  
								   ArrayList<String> tableAttributeList)
	{
		super(viewName, tableAttributeList, true);
		this.viewName = viewName.toLowerCase();
		this.tableAttributeList = tableAttributeList;
		int start = arrayString.indexOf("..");
		lowerBound = arrayString.substring(0, start);
		upBound = arrayString.substring(start+2, arrayString.length());
	}
	
	public DefinedArrayTableSchema(String viewName, 
			  String arrayString)
	{
		this(viewName, arrayString, null);
	}
	
	public String toString()
	{
		return viewName + "[" + lowerBound + "..." + upBound + "]";
	}


	/* (non-Javadoc)
	 * @see component.sqlExpression.SQLExpression#acceptVisitor(astVisitor.ASTVisitor)
	 */
	@Override
	public boolean acceptVisitor(ASTVisitor astVisitor) throws Exception{
		return astVisitor.visitDefinedArrayTableSchemaExpression(this);
	}
	
}
