/**
 * 
 */
package simsql.compiler; // package mcdb.compiler.parser.astVisitor;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;

// import mcdb.catalog.Attribute;
// import mcdb.catalog.DataAccess;
// import mcdb.catalog.View;
// import mcdb.compiler.parser.expression.sqlExpression.DefinedTableSchema;
// import mcdb.compiler.parser.expression.sqlType.GeneralRandomTableStatement;

/**
 * @author Bamboo
 *
 */
public class GeneralRandomTableTypeChecker extends RandomTableTypeChecker
{

	/**
	 * @param allowDuplicatedAttributeAlias
	 * @throws Exception
	 */
	public GeneralRandomTableTypeChecker(boolean allowDuplicatedAttributeAlias)
			throws Exception {
		super(allowDuplicatedAttributeAlias);
	}

	/**
	 * @param generalRandomTableStatement
	 * @return
	 */
	public boolean visitGeneralRandomTableStatement(
			GeneralRandomTableStatement generalRandomTableStatement) throws Exception
	{
		boolean subCheck = super.visitRandomTableStatement(generalRandomTableStatement);
		
		return subCheck;
	}

	public void saveView(DefinedTableSchema tableAttributes, 
            ArrayList<Integer> gottenAttributeTypeList,
            String sql) throws Exception
	{
		String viewName;
		
		viewName = tableAttributes.viewName;
		
		ArrayList<String> attributeNameList = tableAttributes.tableAttributeList;
		ArrayList<Integer> attributeTypeList = gottenAttributeTypeList;

		ArrayList<Attribute> schema = new ArrayList<Attribute>();
		// The view explicitly define the schema
		if (attributeNameList != null) {
			for (int i = 0; i < attributeNameList.size(); i++) {
				String name = attributeNameList.get(i);
				int type = attributeTypeList.get(i);
				Attribute attribute = new Attribute(name, type, viewName);
				schema.add(attribute);
			}
		}
		else {
			for (int i = 0; i < attributeTypeList.size(); i++) {
				String name = attributeList.get(i);
				int type = attributeTypeList.get(i);
				Attribute attribute = new Attribute(name, type, viewName);
				schema.add(attribute);
			}
		}

		View view = new View(viewName, sql, schema, DataAccess.OBJ_RANDRELATION);
		catalog.addView(view);
		
		int end = viewName.lastIndexOf("_");
		String realViewName = viewName.substring(0, end);
		catalog.addIndexTable(realViewName, viewName);
		
		catalog.addMCDependecy(viewName, this.getIndexedRandomTableList());
	}
}
