package simsql.compiler;


public class GeneralTableName extends SQLExpression{
	private String name;
	private MathExpression indexExp;
	
	
	public GeneralTableName(String name, MathExpression indexExp) {
		super();
		this.name = name;
		this.indexExp = indexExp;
	}

	
	public String getName() {
		return name;
	}


	public void setName(String name) {
		this.name = name;
	}
	
	public String getVersionedName()
	{
		String indexString = new MPNGenerator(indexExp).convertToMPN();
		return name + "_" + indexString;
	}


	public MathExpression getIndexExp() {
		return indexExp;
	}


	public void setIndexExp(MathExpression indexExp) {
		this.indexExp = indexExp;
	}


	@Override
	public boolean acceptVisitor(ASTVisitor astVisitor) throws Exception {
		return astVisitor.visitGeneralTableNameTable(this);	
	}

}
