package simsql.compiler;


public class GeneralTableNameArray extends SQLExpression{

	private String name;
	private MathExpression lowerBoundExp;
	private MathExpression upBoundExp;
	
	public GeneralTableNameArray(String name, MathExpression lowerBoundExp,
			MathExpression upBoundExp) {
		super();
		this.name = name;
		this.lowerBoundExp = lowerBoundExp;
		this.upBoundExp = upBoundExp;
	}


	public MathExpression getLowerBoundExp() {
		return lowerBoundExp;
	}


	public void setLowerBoundExp(MathExpression lowerBoundExp) {
		this.lowerBoundExp = lowerBoundExp;
	}


	public MathExpression getUpBoundExp() {
		return upBoundExp;
	}


	public void setUpBoundExp(MathExpression upBoundExp) {
		this.upBoundExp = upBoundExp;
	}


	public String getName() {
		return name;
	}


	public void setName(String name) {
		this.name = name;
	}
	
	public String getVersionUpName()
	{
		String indexString = new MPNGenerator(upBoundExp).convertToMPN();
		return name + "_" + indexString;
	}

	public String getVersionLowerName()
	{
		String indexString = new MPNGenerator(lowerBoundExp).convertToMPN();
		return name + "_" + indexString;
	}
	
	@Override
	public boolean acceptVisitor(ASTVisitor astVisitor) throws Exception {
		return astVisitor.visitGeneralTableNameArray(this);	
	}

}
