/**
 * 
 */
package simsql.compiler; // package mcdb.compiler.logicPlan.logicOperator.booleanOperator;


// import mcdb.compiler.logicPlan.logicOperator.CopyHelper;

/**
 * @author Bamboo
 *
 */
public class NotOperator extends BooleanOperator {

	private BooleanOperator booleanOperator;
	/**
	 * @param name
	 */
	public NotOperator(String name) {
		super(name);
	}
	
	public NotOperator(String name, BooleanOperator booleanOperator) {
		super(name);
		this.booleanOperator = booleanOperator;
	}
	
	public BooleanOperator getBooleanOperator() {
		return booleanOperator;
	}
	
	public void setBooleanOperator(BooleanOperator booleanOperator) {
		this.booleanOperator = booleanOperator;
	}

	/* (non-Javadoc)
	 * @see logicOperator.booleanOperator.BooleanOperator#visitNode()
	 */
	@Override
	public String visitNode() {
		String result = "boolNot(" + this.getName() + ", [";
		result += booleanOperator.getName();
		result += "]).\r\n";
		
		result += booleanOperator.visitNode();
		
		return result;
	}

	/* (non-Javadoc)
	 * @see mcdb.compiler.logicPlan.logicOperator.booleanOperator.BooleanOperator#copy()
	 */
	@Override
	public BooleanOperator copy(CopyHelper copyHelper) {
		String c_name = new String(this.getName());
		return new NotOperator(c_name, this.booleanOperator.copy(copyHelper));
	}
	
}
