package simsql.compiler; // package mcdb.compiler.parser.expression.mathExpression;


import java.util.ArrayList;
// import mcdb.catalog.Attribute;
// import mcdb.compiler.parser.astVisitor.ASTVisitor;


/*
 * @Author: Bamboo
 *  Date: 09/02/2010
 *  This class corresponds to numeric expression
 */

public class NumericExpression extends MathExpression{
	public double value;
	public int type;
	
	public NumericExpression(String valueString)
	{
		value = new Double(valueString).doubleValue();
		if(valueString.indexOf(".") >= 0)
		{
			type = Attribute.DOUBLE;
		}
		else
		{
			type = Attribute.INTEGER;
		}
	}

	@Override
	public ArrayList<Integer> acceptVisitor(ASTVisitor astVisitor)  throws Exception{
		return astVisitor.visitNumericExpression(this);	
	}
	
	public int getType()
	{
		return type;
	}
	
	@Override
	public String toString()
	{
		if(type == Attribute.DOUBLE)
			return ""+value;
		else
			return "" + (int)value;
	}
}
