/**
 * 
 */
package simsql.compiler; // package mcdb.compiler.parser.astVisitor.rule;

import java.util.ArrayList;
import java.util.HashMap;


// import mcdb.catalog.Attribute;
// import mcdb.compiler.parser.astVisitor.*;
// import mcdb.compiler.parser.expression.mathExpression.AggregateExpression;
// import mcdb.compiler.parser.expression.mathExpression.ArithmeticExpression;
// import mcdb.compiler.parser.expression.mathExpression.MathExpression;


/**
 * @author Bamboo
 *
 */
public class TypeCheckerHelper {
	public static final int BASELINE_RANDOM_TABLE_TYPECHECKER = 0;
	public static final int GENERAL_RANDOM_TABLE_TYPECHECKER = 1;
	public static final int RANDOM_TABLE_TYPECHECKER = 2;
	public static final int VIEW_TYPECHECKER = 3;
	public static final int TABLE_DEFINE_CHECKER = 4;
	public static final int VGFUNC_DEFINE_CHECKER = 5;
	public static final int TYPECHECKER = 6;
	public static final int BASELINE_ARRAY_RANDOM_TABLE_TYPECHECKER = 7;
	public static final int UNION_VIEW_TYPECHECKER = 8;
	
	public static boolean hasAggregate(MathExpression expression)
	{
		if(expression instanceof AggregateExpression)
		{
			return true;
		}
		else if(expression instanceof ArithmeticExpression)
		{
			ArrayList<MathExpression> operandList = ((ArithmeticExpression) expression).operandList;
			for(int i = 0; i < operandList.size(); i++)
			{
				MathExpression temp = operandList.get(i);
				if(hasAggregate(temp))
				{
					return true;
				}
			}
		}
		return false;
	}
	
	
	public static int arithmeticCompatibleType(int type[])
	{
		int compatibleResult = type[0];
		
		for(int i = 1; i < type.length; i++)
		{
			if(compatibleResult == -1)
				return -1;
			
			compatibleResult = arithmeticCompate(compatibleResult, type[i]);
		}
		return compatibleResult;
	}
	
	/*
	 * 1. Allowed expression:
	 * 	   number + number, number + date, date+date
	 */
	public static int arithmeticCompate(int type_1, int type_2)
	{
		/*
		int INTEGER = 1;
	    int DOUBLE = 2;
	    int STRING = 3;
	    int DATE = 4;
	    int STOCHINT = 5;
	    int STOCHDBL = 6;
	    int STOCHDAT = 7;
	    int SEED = 8;
	    */
		
		String type1String ="", type2String ="";
		
		switch(type_1)
		{
			case Attribute.INTEGER:
			case Attribute.DOUBLE:
			case Attribute.STOCHINT:
			case Attribute.STOCHDBL:
			case Attribute.SEED:
				type1String = "NUMERIC";
				break;
			
			case Attribute.STRING:
				type1String = "STRING";
				break;
				
			case Attribute.DATE:
			case Attribute.STOCHDAT:
				type1String = "DATE";
				break;	
		}
		
		switch(type_2)
		{
			case Attribute.INTEGER:
			case Attribute.DOUBLE:
			case Attribute.STOCHINT:
			case Attribute.STOCHDBL:
			case Attribute.SEED:
				type2String = "NUMERIC";
				break;
			
			case Attribute.STRING:
				type2String = "STRING";
				break;
				
			case Attribute.DATE:
			case Attribute.STOCHDAT:
				type2String = "DATE";
				break;	
		}
		
		if(type1String.equals(type2String) && !type1String.equals("STRING"))
			return type_1;
		
		if((type1String.equals("NUMERIC") && type1String.equals("DATE")) ||
		   (type2String.equals("DATE")    && type2String.equals("NUMERIC")))
		{
			return Attribute.DOUBLE;
		}
		
		return -1;
	}
	
	public static int directTransfer(int sourceType, int tagetType)
	{
		if(tagetType == Attribute.MULTITYPE)
			return tagetType;
		
		if(sourceType == tagetType)
			return tagetType;
		
		if(sourceType == Attribute.INTEGER
				&& tagetType == Attribute.DOUBLE)
			return Attribute.DOUBLE;
		else if(sourceType == Attribute.STOCHINT && 
				tagetType == Attribute.STOCHDBL)
			return Attribute.STOCHDBL;
		else if(sourceType == Attribute.DATE && 
				tagetType == Attribute.STRING)
			return Attribute.STRING;
		
		return -1;
	}
	
	/*
	 * 1. Allowed expression:
	 * 	   number + number, number + date, date+date
	 */
	public static int comparisonCompate(int type_1, int type_2)
	{
		if(type_1 == type_2)
			return type_1;
		
		String type1String ="", type2String ="";
		
		switch(type_1)
		{
			case Attribute.INTEGER:
			case Attribute.DOUBLE:
			case Attribute.STOCHINT:
			case Attribute.STOCHDBL:
			case Attribute.SEED:
				type1String = "NUMERIC";
				break;
			
			case Attribute.STRING:
				type1String = "STRING";
				break;
				
			case Attribute.DATE:
			case Attribute.STOCHDAT:
				type1String = "DATE";
				break;	
		}
		
		switch(type_2)
		{
			case Attribute.INTEGER:
			case Attribute.DOUBLE:
			case Attribute.STOCHINT:
			case Attribute.STOCHDBL:
			case Attribute.SEED:
				type2String = "NUMERIC";
				break;
			
			case Attribute.STRING:
				type2String = "STRING";
				break;
				
			case Attribute.DATE:
			case Attribute.STOCHDAT:
				type2String = "DATE";
				break;	
		}
		
		if(type1String.equals(type2String))
		{
			if(type1String.equals("NUMERIC"))
				return Attribute.DOUBLE;
			else if(type1String.equals("DATE"))
				return Attribute.DATE;
			else if(type1String.equals("STRING"))
				return Attribute.STRING;
		}
		
		if((type1String.equals("NUMERIC") && type2String.equals("DATE")) ||
				   (type1String.equals("DATE")    && type2String.equals("NUMERIC")))
		{
			return Attribute.DOUBLE;
		}
		
		if((type1String.equals("STRING") && type2String.equals("DATE")) ||
				   (type1String.equals("DATE")    && type2String.equals("STRING")))
		{
			return Attribute.STRING;
		}
		
		return -1;
	}

	/*
	 *  public static final int BASELINE_RANDOM_TABLE_TYPECHECKER = 0;
	 *	public static final int GENERAL_RANDOM_TABLE_TYPECHECKER = 1;
	 *	public static final int RANDOM_TABLE_TYPECHECKER = 2;
	 *	public static final int VIEW_TYPECHECKER = 3;
	 *	public static final int TABLE_DEFINE_CHECKER = 4;
	 *	public static final int VGFUNC_DEFINE_CHECKER = 5;
	 *	public static final int TYPECHECKER = 6;
	 */
	public static int getCheckerType(TypeChecker typeChecker)
	{
		if(typeChecker instanceof BaseLineRandomTableTypeChecker)
		{
			return BASELINE_RANDOM_TABLE_TYPECHECKER;
		}
		else if(typeChecker instanceof GeneralRandomTableTypeChecker)
		{
			return GENERAL_RANDOM_TABLE_TYPECHECKER;
		}
		else if(typeChecker instanceof RandomTableTypeChecker)
		{
			return RANDOM_TABLE_TYPECHECKER;
		}
		else if(typeChecker instanceof ViewTypeChecker)
		{
			return VIEW_TYPECHECKER;
		}
		else if(typeChecker instanceof TableDefineChecker)
		{
			return TABLE_DEFINE_CHECKER;
		}
		else if(typeChecker instanceof VGFunctionDefineChecker)
		{
			return VGFUNC_DEFINE_CHECKER;
		}
		else if(typeChecker instanceof BaselineArrayRandomTypeChecker)
		{
			return BASELINE_ARRAY_RANDOM_TABLE_TYPECHECKER;
		}
		else if(typeChecker instanceof UnionViewStatementTypeChecker)
		{
			return UNION_VIEW_TYPECHECKER;
		}
		else 
		{
			return TYPECHECKER;
		}
	}
}
