/**
 * 
 */
package simsql.compiler; // package mcdb.compiler.parser.grammar;

import java.util.ArrayList;
import java.util.HashSet;

/**
 * @author Bamboo
 *
 */
public class ValuesTable
{
	private ArrayList<ArrayList<MathExpression>> tempTableRowList;
	private ArrayList<Integer> schemaTypeList;
	
	public ValuesTable(ArrayList<ArrayList<MathExpression>> _tempTableRowList)
	{
		tempTableRowList = _tempTableRowList;
		schemaTypeList = getType();
	}
	
	@Override
	public String toString()
	{
		String result = "[";
		if(tempTableRowList != null)
		{
			for(int i = 0; i < tempTableRowList.size(); i++)
			{
				ArrayList<MathExpression> row = tempTableRowList.get(i);
				result += "\t";
				
				for(int j = 0; j < row.size(); j++)
				{
					result += row.get(j);
					result += " ";
				}
				result += "\r\n";
			}
		}
		
		result += "]";
		return result;
	}

	public ArrayList<ArrayList<MathExpression>> getTempTableColumnList() {
		return tempTableRowList;
	}
	
	private ArrayList<Integer> getType()
	{
		int type;
		ArrayList<Integer> attributeTypeList = new ArrayList<Integer>();
		//1. judge all the elements in the values definition.
		ArrayList<MathExpression> row = tempTableRowList.get(0);
		
		for(int j = 0; j < row.size(); j++)
		{
			MathExpression fromElement = row.get(j);
			
			if(fromElement instanceof DateExpression)
			{
				type = Attribute.DATE;
				attributeTypeList.add(type);
			}
			else if(fromElement instanceof NumericExpression)
			{
				type = ((NumericExpression) fromElement).getType();
				attributeTypeList.add(type);
			}
			else if(fromElement instanceof StringExpression)
			{
				type = Attribute.STRING;
				attributeTypeList.add(type);
			}
		}
		return attributeTypeList;
	}
	
	public ArrayList<Integer> getSchemaTypeList() {
		return schemaTypeList;
	}

	public ArrayList<Integer> getSchemaTypeSize()
	{
		ArrayList<Integer> schemaTypeSizeList = new ArrayList<Integer>();
		//1. judge all the elements in the values definition.
		ArrayList<MathExpression> row = tempTableRowList.get(0);
		int size[] = new int[row.size()];
		             		
		for(int j = 0; j < row.size(); j++)
		{
			size[j] = 0;
		}
		
		for(int i = 0; i < tempTableRowList.size(); i++)
		{
			row = tempTableRowList.get(i);
			for(int j = 0; j < row.size(); j++)
			{
				MathExpression fromElement = row.get(j);
				
				if(fromElement instanceof DateExpression)
				{
					size[j] += ((DateExpression)(fromElement)).value.length()*32;
				}
				else if(fromElement instanceof NumericExpression)
				{
					size[j] += 64;
				}
				else if(fromElement instanceof StringExpression)
				{
					size[j] += ((StringExpression)(fromElement)).value.length()*32;
				}
			}
		}
		
		for(int i = 0; i < size.length; i++)
		{
			schemaTypeSizeList.add((int)(size[i]/tempTableRowList.size()));
		}
		
		return schemaTypeSizeList;
	}
	
	public ArrayList<Integer> getSchemaUniqueValueSize()
	{
		ArrayList<Integer> schemaUniqueValueSizeList = new ArrayList<Integer>();
		
		ArrayList<HashSet<String>> uniqueValueSet = new ArrayList<HashSet<String>>();
		ArrayList<MathExpression> row = tempTableRowList.get(0);
		for(int i = 0; i < row.size(); i++)
		{
			uniqueValueSet.add(new HashSet<String>());
		}
		
		for(int i = 0; i < tempTableRowList.size(); i++)
		{
			row = tempTableRowList.get(i);
			for(int j = 0; j < row.size(); j++)
			{
				MathExpression fromElement = row.get(j);
				
				if(fromElement instanceof DateExpression)
				{
					uniqueValueSet.get(j).add(((DateExpression)(fromElement)).value);
				}
				else if(fromElement instanceof NumericExpression)
				{
					uniqueValueSet.get(j).add(((NumericExpression)(fromElement)).value + "");
				}
				else if(fromElement instanceof StringExpression)
				{
					uniqueValueSet.get(j).add(((StringExpression)(fromElement)).value);
				}
			}
		}
		
		for(int i = 0; i < uniqueValueSet.size(); i++)
		{
			schemaUniqueValueSizeList.add(uniqueValueSet.get(i).size());
		}
		
		return schemaUniqueValueSizeList;
	}
}
