package simsql.functions;

import simsql.runtime.*;
import java.text.*;
import java.util.*;

/**
 * Evaluates the logistic CDF function.
 *
 * @author Luis.
 */

public class logisticCDF extends ReflectedFunction {

    public static double logistic_cdf(double x, double intercept, double coef) {
        return 1.0 / (1 + Math.exp(-1*(intercept + (x*coef))));
    }

    public logisticCDF() {
	super("simsql.functions.logisticCDF", "logistic_cdf", double.class, double.class, double.class);
    }
    

    @Override
    public String getName() {
	return "logisticCDF";
    }
}