package simsql.functions;

import simsql.runtime.*;
import java.text.*;
import java.util.*;

/** 
 * A date function reflected from its own method.
 *
 * @author Luis.
 */

public class month extends ReflectedFunction {

    private static SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
    private static Calendar cal = Calendar.getInstance();

    public static int monthfn(String date) {
        try {
            cal.setTime(sdf.parse(date));
            return cal.get(Calendar.MONTH);
        } catch (Exception e) {
            throw new RuntimeException("Failed to parse date string " + date);
        }
    }

    public month() {
	super("simsql.functions.month", "monthfn", String.class);
    }

    @Override
    public String getName() {
	return "month";
    }
}