package simsql.functions;

import java.util.*;
import simsql.runtime.*;
import java.net.*;
import java.lang.*;
import java.lang.management.*;

/**
 * A function that returns a positive integer if an input attribute is
 * NULL, zero otherwise.
 *
 * @author Luis.
 */
public class nullfn extends Function {

	// simple constructor
	public nullfn() {
		super(AttributeType.DOUBLE);
	}

	public Attribute apply(Attribute... atts) {
		if (atts.length == 0)
			return new IntAttribute(1);

		return atts[0].isNull().toInt();
	}

	public Attribute eval() {
		return new IntAttribute(0);
	}

	public String getName() {
		return "nullfn";
	}

	public AttributeType getOutputType() {
		return AttributeType.INT;
	}
}