package simsql.functions;

import simsql.runtime.*;
import java.text.*;
import java.util.*;

/** 
 * A date function reflected from its own method.
 *
 * @author Luis.
 */

public class year extends ReflectedFunction {

    private static SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
    private static Calendar cal = Calendar.getInstance();

    public static int yearfn(String date) {
        try {
            cal.setTime(sdf.parse(date));
            return cal.get(Calendar.YEAR);
        } catch (Exception e) {
            throw new RuntimeException("Failed to parse date string " + date);
        }
    }

    public year() {
	super("simsql.functions.year", "yearfn", String.class);
    }

    @Override
    public String getName() {
	return "year";
    }
}