# Makefile for building individual VG functions

ECHO = echo
CCFLAGS = -c -fPIC -O3
CLFLAGS = -lgsl -lgslcblas -ldl -shared -rdynamic
RM = rm -f
BASENAME = basename
LFUNC=$(shell $(BASENAME) $(FUNC) .vg.cc)

.SILENT: all

all: $(FUNC)
	$(ECHO) "\033[1m\033[31mBuilding VG function '$(LFUNC)'.\033[0m"
	$(CC) -I $(INCLUDE) $(CCFLAGS) $(FUNC) -o $(LFUNC).vg.o
	$(CC) -o $(OUTDIR)/$(LFUNC).vg.so $(LFUNC).vg.o $(CLFLAGS)
	$(RM) $(LFUNC).vg.o

clean:
	$(RM) $(LFUNC).vg.o
