package simsql.optimizer;

import simsql.shell.SimSQLCompiledQuery;
import simsql.shell.FileOutput;
import java.util.HashMap;
import java.util.ArrayList;

/**
 * A class for the output of an optimized query, including data on
 * materialized views that passes through the compiler.
 *
 * @author Luis
 */
public class SimSQLOptimizedQuery extends FileOutput {

  // materialized views and their attributes
  private HashMap<String, ArrayList<String>> materializedViewAtts = new HashMap<String, ArrayList<String>>();
  public SimSQLOptimizedQuery(String extension, SimSQLCompiledQuery cQuery) {
    super(extension);
    materializedViewAtts.putAll(cQuery.getMaterializedViews());
  }

  public ArrayList<String> getMaterializedViews() {
    ArrayList<String> materializedViews = new ArrayList<String>();
    materializedViews.addAll(materializedViewAtts.keySet());

    return materializedViews;
  }

  public ArrayList<String> getViewAtts(String viewName) {
    ArrayList<String> viewAtts = new ArrayList<String>();
    viewAtts.addAll(materializedViewAtts.get(viewName));

    return viewAtts;
  }
}