:- dynamic function/3.
:- multifile function/3.

%%% This "loader" is responsible for handling command-line parameters.

go :-
    current_prolog_flag(argv, Args),
    go(Args).

go([_, Command, FileIn, NumIters1, MaxPlans1, FileOut]) :-
    command_ok(Command),
    style_check(-discontiguous),
    load_files([FileIn], [silent(true), scope_settings(true)]),
    atom_number(NumIters1, NumIters),
    atom_number(MaxPlans1, MaxPlans),
    !,
    optimize(Command, NumIters, MaxPlans, NumPlans, TotalTime, Applied, PlansIter, FileOut),
    !,
    writeq(NumPlans), nl,
    writeq(TotalTime), nl,
    writeq(Applied), nl,
    writeq(PlansIter), nl,
    !,
    halt(0).

go([_|_]) :-
    halt(1).

command_ok(optimize).
command_ok(cut).
