
package simsql.runtime;

/**
 * This class is used to store aggregate operations of the form
 *
 * var = aggType(expression)
 */
class AggregateExp {

    public enum Type {
	COUNT, COUNTALL, SUM, AVG, VAR, STDEV, MAX, MIN
    }

    private String identifier;
    private AggregateExp.Type type;
    private Expression exp;

    public String getIdentifier() {
	return identifier;
    }

    public AggregateExp.Type getType() {
	return type;
    }

    public Expression getExpression() {
	return exp;
    }

    public String print() {
	return identifier + ": " + type.toString() + "(" + exp.print() + ")";
    }

    public AggregateExp(String id, String t, Expression e) {
	identifier = id;
	exp = e;
	type = AggregateExp.Type.valueOf(t.toUpperCase());
	if (type == null) {
	    throw new RuntimeException("Unrecognized aggregate type " + t);
	}
    } 
}
