
package simsql.runtime;

/**
 * This class is used to store assignments of the form
 * 
 * var = expression
 * 
 * where "var" is an identifier, and "expression" is a parsed expression.
 */
class Assignment {
  
  private String identifier;
  private Expression exp;
  
  public Assignment (String idIn, Expression expIn) {
    identifier = idIn;
    exp = expIn;
  }
  
  public String getIdentifier () {
    return identifier; 
  }
  
  public Expression getExpression () {
    return exp;
  }
  
  public String print () {
    return identifier + ": " + exp.print (); 
  }
}
