
package simsql.runtime;

import org.apache.hadoop.io.serializer.Serialization;

/**
 * Because hadoop is a bit convoluted in how you specify a record serializer/deserializer,
 * you need to have these two classes that serve as a factory for record and recordkey
 * serializers and deserializers
 */

class RecordSerialization implements Serialization <WritableValue> {
  
  public boolean accept (Class <?> c) {
    return c.equals (RecordWrapper.class) || WritableValue.class.isAssignableFrom(c);
  }
  
  public RecordSerializer getSerializer (Class <WritableValue> c) {
    return new RecordSerializer ();
  }
    
  public RecordDeserializer getDeserializer (Class <WritableValue> c) {
    return new RecordDeserializer ();
  }
  
}

class RecordKeySerialization implements Serialization <WritableKey> {
  
  public boolean accept (Class <?> c) {
    return c.equals (RecordKey.class) || WritableKey.class.isAssignableFrom(c);
  }
  
  public RecordKeySerializer getSerializer (Class <WritableKey> c) {
    return new RecordKeySerializer ();
  }
  
  public RecordKeyDeserializer getDeserializer (Class <WritableKey> c) {
    return new RecordKeyDeserializer ();
  }
  
}
