
package simsql.runtime;

import java.io.OutputStream;
import java.io.DataOutputStream;
import org.apache.hadoop.io.serializer.Serializer;
import java.io.IOException;

class RecordSerializer implements Serializer <WritableValue> {

  // this is where we actually write the result of the serialization
  private DataOutputStream writeToMe;
  
  public void close () throws IOException {
    if (writeToMe != null)
      writeToMe.close ();
  }
  
  public void open (OutputStream out) throws IOException {
    writeToMe = new DataOutputStream (out); 
  }
    
  public void serialize (WritableValue value) throws IOException {
    value.writeSelfToStream (writeToMe); 
  }
}
