
package simsql.runtime;

import java.util.*;
import java.io.*;

/**
 * Interacts with the property file in a static manner, facilitating
 * retrieval of properties in a single line.
 *
 * @author Luis
 */

public class Property {
    private static Properties props;
    
    // default loading block
    static {
	props = new Properties();
	try {
	    InputStream in = Property.class.getResourceAsStream("simsql.properties");
	    props.load(in);
	    in.close();
	} catch (IOException e) {
	    throw new RuntimeException("Could not load default properties file!", e);
	}
    }

    /** Returns a given property. */
    public static String get(String propName) {
	String ret = props.getProperty(propName);
	if (ret == null) {
	    throw new RuntimeException("Could not retrieve property " + propName);
	}
	
	return(ret);
    }
}
