
package simsql.runtime;

import java.util.ArrayList;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Constructor;
import java.lang.Thread;
import java.util.Set;
import java.lang.ClassLoader;

// a node in the pipe network
abstract class APipeNode implements PipeNode {

	private PipelinedOperator myOp;

	protected void getReadyToRun (String classToLoad) {

		try {
			classToLoad = classToLoad.substring (0, classToLoad.length () - 6);
			Class <?> myClass = Class.forName ("simsql.runtime." + classToLoad);
			Constructor <?> myConstructor = myClass.getConstructor ();
			myOp = (PipelinedOperator) myConstructor.newInstance ();
		} catch (NoSuchMethodException e) {
			throw new RuntimeException ("I could not find a valid contructor for the pipelined operator");
		} catch (InstantiationException e) {
			throw new RuntimeException ("I could not create a pipelined operator (1)");
		} catch (IllegalAccessException e) {
			throw new RuntimeException ("I could not create a pipelined operator (2)");
		} catch (InvocationTargetException e) {
			throw new RuntimeException (e.getCause ());
		} catch (ClassNotFoundException e) {
			throw new RuntimeException ("I could not find the class to run the pipelined operator: " + classToLoad);
		}
				
	}

	public PipelinedOperator getOperator () {
		return myOp;
	}

        public ArrayList <Record> cleanup () {
		return new ArrayList <Record> ();
        }

	// default is to return nothing
	public Set <String> findPipelinedSortAtts (Set <Set <String>> currentAtts) {
		return null;
	}
} 
