
package simsql.runtime;

import simsql.runtime.AbstractRecord;

// this little class is used to builk load a database file
public class LoaderRecord extends AbstractRecord {

  static private int numAttsLR;
  static private short typeCodeLR;

  // [updated to make it possible to have multiple RecordIterators at the same time]
  static private boolean haveMultiple = false;
  private int numAttsMult;
  private short typeCodeMult;

  static public void setup (int numAttsLRIn, short typeCodeLRIn) {
    numAttsLR = numAttsLRIn;
    typeCodeLR = typeCodeLRIn;
  }

  static public void setMultiple(boolean mult) {
    haveMultiple = mult;
  }

  public LoaderRecord () {
    this(numAttsLR, typeCodeLR);
  }

  public LoaderRecord(int numAttsIn, short typeCodeIn) {
    numAttsMult = numAttsIn;
    typeCodeMult = typeCodeIn;
    atts = new Attribute [getNumAttributes()];
  }

  @Override
  public Record buildRecordOfSameType() {
    return haveMultiple ? new LoaderRecord(numAttsMult, typeCodeMult) : new LoaderRecord(numAttsLR, typeCodeLR);
  }
  
  public short getTypeCode () {
    return haveMultiple ? typeCodeMult : typeCodeLR;
  }

  public int getNumAttributes () {
    return haveMultiple ? numAttsMult : numAttsLR;
  }
}
