
package simsql.runtime;

/**
 * This class is used to facilitate fast sorting and comparing of records...
 * that way, the records themselves do not have to be deserialized during
 * sorting... instead, the keys can be looked at directly
 */
public class RecordKey implements WritableKey {
  
  // this is generally going to be the hash key of a record
  private long key;
  
  // this is generally going to be the file key of a record... it can
  // be used to make sure the records from one file come first to the
  // reducer
  private short typeCode;
  
  // "getters" for the two values
  public long getKey () {
    return key;
  }
  
  public short getTypeCode () {
    return typeCode;
  }
  
  // sets all of the fields
  public void set (long keyIn, short typeCodeIn) {
        
    if (keyIn < 0)
      throw new RuntimeException ("hash value of " + keyIn + " typecode is " + typeCodeIn);
    
    key = keyIn;
    typeCode = typeCodeIn;
  }
  
  // simple constructor
  public RecordKey (long keyIn, short typeCodeIn) {
    
    if (keyIn < 0)
      throw new RuntimeException ("hash value of " + keyIn + " typecode is " + typeCodeIn);
    
    key = keyIn;
    typeCode = typeCodeIn;
  }
  
  // no param constructor
  public RecordKey () {
    key = -1;
    typeCode = -1;
  }
}
