package simsql.runtime;
import java.io.*;

/**
 * These empty interfaces are used to enforce correctness on the
 * generics for operators that might have map-only jobs (like
 * selections and joins) and could call context.write() on different
 * object types, depending on the situation.
 *
 * To use them, just put <WritableKey, WritableValue> on the
 * declaration of your mapper class.
 * 
 */
interface WritableKey {
  long getKey();
  short getTypeCode();
  void set (long key, short code);
}

interface WritableValue {
  int writeSelfToStream (DataOutputStream writeToMe) throws IOException;
  int readSelfFromStream (DataInputStream readFromMe) throws IOException;
}

