
package simsql.shell;

/**
 * This encapsultes a compiled query
 */
public interface CompiledQuery {

  // If there was an error encountered when compiling the query, this function
  // should return a nice text that describes the error.  If there was no error,
  // then this returns a "null"
  String isError ();
  
  // see if the thing is empty and there is nothing to process... this might happen
  // if we are given a CREATE TABLE statement, for example
  public boolean isEmpty ();

  // this "cleans up" the compiled query, by (for example) removing any files that
  // were created to store the contents of the query
  void cleanUp ();
  
}
