
package simsql.shell;

// this class is used to deal with an unexpected shutdown... there are a lot of race
// condintions in here, so it can potentially fail, but it is better than nothing...

public class ShutdownHook <MyCompiledQuery extends CompiledQuery, MyOptimizedQuery extends OptimizedQuery, 
	MyExecutableQuery extends ExecutableQuery, MyRuntimeOutput extends RuntimeOutput, 
	MyQueryProcessor extends QueryProcessor<MyCompiledQuery, MyOptimizedQuery, MyExecutableQuery, MyRuntimeOutput>> {

	// this is the query processor
	MyQueryProcessor myQueryProcessor;

	// called to set up at least some rudimentary shutdown robustness
	public void attachShutDownHook(MyQueryProcessor processorIn) {
		
		myQueryProcessor = processorIn;

		java.lang.Runtime.getRuntime().addShutdownHook(new Thread() {
			@Override
			public void run() {

				// if we are currently running a simulation, then we attempt to save its state 
				if (myQueryProcessor.getIteration () != -1) { 
					myQueryProcessor.killRuntime ();
					System.out.println ("Killed on iteration " + (myQueryProcessor.getIteration () - 1) + ".");
					if (myQueryProcessor.getIteration () >= 2) {
						System.out.println ("Saving results of iteration " + (myQueryProcessor.getIteration () - 2) + ".");
						myQueryProcessor.saveOutputsFromLastIter ();
					}
				} 
			
				// save the catalog and the physical database
				myQueryProcessor.getCatalog().save();
				myQueryProcessor.getRuntimeParameter().save();
				myQueryProcessor.getPhysicalDatabase().save();
			}
		});
	}
}
