
package simsql.shell;

import java.io.File;
public class FileOutput implements CompiledQuery, OptimizedQuery, ExecutableQuery {
  
  // this is the name of the file
  private String fName = null;
  
  // this is the error message (if there)
  private String errMsg = null;
  
  // tells if there is nothing to process
  private boolean isEmp = false;
  
  // record the fact that there is nothig to process in the file
  public void setEmpty () {
    isEmp = true;
  }
  
  // see if the thing is empty and there is nothing to process
  public boolean isEmpty () {
    return isEmp;
  }
  
  // this gets the name of the file
  public String getFName () {
    return fName;
  } 
  
  // this constructor creates a new (empty) file with the given extension
  public FileOutput (String extension) {
    
    // loop through all of the file names until we sucessfully create one
    try {
      for (int i = 0; true; i++) {
        fName = "Temp_file_" + i + extension;
        if (new File (fName).createNewFile ()) {
          break; 
        }
      }
    } catch (Exception e) {
      e.printStackTrace ();
      throw new RuntimeException ("Problem occurred when I was trying to create a temp file");
    }
  }
  
  // this should be called to record an error
  public void setError (String setToMe) {
    errMsg = setToMe;
  }
  
  // this is called to get the error if it is there
  public String isError () {
    return errMsg;
  }
  
  // and this deletes the underlying file
  public void cleanUp () {
    new File (fName).delete ();
  }
}
